<?php
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: https://manglikgold.com'); // Allow your specific origin
header('Access-Control-Allow-Methods: POST, OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Authorization, X-Requested-With');

if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    http_response_code(200);
    exit;
}

include "Crypto.php";
include "config.php"; // Assuming this includes your database connection
date_default_timezone_set("Asia/Kolkata");

$_POST = json_decode(file_get_contents("php://input"), true);

$uid = $_POST['id'];
$name = $_POST['name'];
$ad1 = $_POST['ad1'];
$ad2 = $_POST['ad2'];
$pincode = $_POST['pincode'];
$city = $_POST['city'];
$state = $_POST['state'];
$mobile = $_POST['mobile'];
$email = $_POST['email'];
$shipping = $_POST['shipping'];
$coupon = $_POST['coupon'];
$ccode = $_POST['ccode'];
$ctype = $_POST['ctype'];
$agentId = $_POST['agentId'];
$paymethod = "COD";
$payment_id = $_POST['payment_id'];
$order = $_POST['oid'];
$date = date("Y-m-d");
$option = $_POST['option'];
(int)$total = 0;
$price = 0;
$dis_price = 0;

function createtoken()
{
    $data = array(
        'email' => 'shrutinilesh7904@gmail.com',
        'password' => 'Nilesh@1234'
    );

    $url = 'https://shipment.xpressbees.com/api/users/login';

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

    $response = curl_exec($ch);
    $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    if ($httpcode == 200) {
        $responseData = json_decode($response, true);
        return $responseData['data']; // Return the token
    } else {
        return null; // Return null if token retrieval fails
    }
}

function scheduleExpressBeesPickup($order, $total, $coupon, $token, $name, $ad1, $city, $state, $pincode, $mobile, $paymethod, $cc, $pickupDetailsss)
{
    $tt = $coupon ? $coupon : 0;

    $pickupDetails = array(
        'order_number' => $order,
        'payment_type' => "cod",
        'order_amount' => round($total) - round($tt),
        'consignee' => array(
            'name' => $name,
            'address' => $ad1,
            'city' => $city,
            'state' => $state,
            'pincode' => $pincode,
            'phone' => $mobile
        ),
        'pickup' => array(
            'warehouse_name' => 'Manglik Gold',
            'name' => 'Manglik Gold',
            'address' => '34/2 Swaminarayan Nagar, Part-2',
            'address_2' => 'Nikol Road',
            'city' => 'Ahmedabad',
            'state' => 'Gujarat',
            'pincode' => '382350',
            'phone' => '7990202540'
        ),
        'order_items' => $pickupDetailsss, // Use jsonData as order items
        'courier_id' => '',
        'collectable_amount' => round($total) - round($tt)
    );

    $expressBeesApiUrl = 'https://shipment.xpressbees.com/api/shipments2';

    $ch = curl_init($expressBeesApiUrl);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($pickupDetails));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
        'Content-Type: application/json',
        'Authorization: Bearer ' . $token
    ));

    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);
    return $responseData; // Return response data
}

if (!empty($uid)) {
    $ad2 = "";
    $date = date("Y-m-d");
    
    // Fetch cart items and calculate total
    $csql = "SELECT cart.*, products.*, products.price AS pprice, cart.pid AS pid
             FROM cart
             JOIN products ON cart.pid = products.id
             WHERE cart.uid = '$uid' AND products.stock > 0";
    $crun = mysqli_query($conn, $csql);
    $cc = mysqli_num_rows($crun);

    if ($crun) {
        while ($row = mysqli_fetch_array($crun)) {
            $pid = $row["pid"]; 
            $qty = $row["qau"];
            $productId = $row["pid"];
            $net = $row["net"];
            $gross = $row["gross"];
            $dgm = $row["d_gm"];
            $dkarat = $row["d_karat"];
            $material = $row["type"];
            $pprice = $row["pprice"];
            
            $mQuery = "SELECT * FROM material WHERE id='$material'";
            $mResult = mysqli_query($conn, $mQuery);
            $mrow = mysqli_fetch_array($mResult);
            $mname = $mrow["name"];
            $mprice = $mrow["price"];
            
            $dQuery = "SELECT * FROM material WHERE id='5'";
            $dResult = mysqli_query($conn, $dQuery);
            $drow = mysqli_fetch_array($dResult);
            $dprice = $drow["price"];
            $dname = $drow["name"];
            $dtotal = $dprice * $dkarat;

            if ($net > 0.0 && $net < 0.5) {
                $making = $net * 1400;
            } elseif ($net > 0.51 && $net < 0.8) {
                $making = $net * 1650;
            } elseif ($net > 0.81 && $net < 1.0) {
                $making = $net * 2050;
            } elseif ($net > 1.01 && $net < 1.4) {
                $making = $net * 2350;
            } elseif ($net > 1.41 && $net < 1.9) {
                $making = $net * 2600;
            } elseif ($net > 1.91 && $net < 2.2) {
                $making = $net * 2850;
            } else {
                $making = $net * 1500;
            }

            $mm = $making / 2;
            $ggg = $net * $mprice + $mm + $dtotal;

            $gst = $ggg * 0.03;
            if ($pprice == 0 || $pprice == "") {
                $price = $net * $mprice + $mm + $gst + $dtotal;
                $dis_price = $net * $mprice + $making + $gst + $dtotal;
            } else {
                $p = $row["price"];
                $fgst = $row["price"] * 0.03;
                $pp = $row["price"] + $fgst;
                $price = $pp;
                $dis_price = $row["dis_price"] + $row["dis_price"] * 0.03;
            }

            $subTotal = $qty * $price;
            $total += round($subTotal);

            $osql = "INSERT INTO `order`(`uid`, `orderid`, `pid`, `price`, `dis_price`, `qty`, `date`)
                     VALUES ('$uid','$order','$pid','$price','$dis_price','$qty','$date')";
            mysqli_query($conn, $osql);

            $uppro = "UPDATE `products` SET `stock` = `stock` - $qty WHERE `id`='$pid'";
            mysqli_query($conn, $uppro);

            $dcart = "DELETE FROM `cart` WHERE `uid`='$uid'";
            mysqli_query($conn, $dcart);

            if ($ctype == "agent") {
                $agent = "INSERT INTO `agentOrder`(`oid`, `agentCode`, `pid`, `agentId`, `bonus`, `date`) 
                          VALUES ('$order','$ccode','$pid','$agentId','$coupon','$date')";
                mysqli_query($conn, $agent);
            }
        }
    } 

    if ($option != "0") {
        $sqll = "SELECT * FROM `address` WHERE `id`='$option'";
        $roww = mysqli_query($conn, $sqll);
        $runn = mysqli_fetch_array($roww);

        if ($runn) {
            $name1 = $runn["name"];
            $ad11 = $runn["ad1"];
            $ad21 = $runn["ad2"];
            $city1 = $runn["city"];
            $state1 = $runn["state"];
            $pincode1 = $runn["pincode"];
            $mobile1 = $runn["mobile"];
            $email1 = $runn["email"];

            $sql = "INSERT INTO `checkout`(`uid`, `orderid`, `name`, `ad1`, `ad2`, `city`, `state`, `pincode`, `mobile`, `email`, `pay_id`, `pay_method`, `status`, `shipping`, `coupon`, `c_code`, `c_type`, `agent_id`, `total`, `date`) 
                    VALUES ('$uid','$order','$name1','$ad11','$ad21','$city1','$state1','$pincode1','$mobile1','$email1','$payment_id','COD','pending','$shipping','$coupon','$ccode','$ctype','$agentId','$total','$date')";
            $row = mysqli_query($conn, $sql);
        }
    } else {
        $sqlAddress = "INSERT INTO `address`(`uid`, `name`, `ad1`, `ad2`, `pincode`, `state`, `city`, `mobile`, `email`, `date`) 
                       VALUES ('$uid','$name','$ad1','$ad2','$pincode','$state','$city','$mobile','$email','$date')";
        mysqli_query($conn, $sqlAddress);

        $sqlCheckout = "INSERT INTO `checkout`(`uid`, `orderid`, `name`, `ad1`, `ad2`, `city`, `state`, `pincode`, `mobile`, `email`, `pay_id`, `pay_method`, `status`, `shipping`, `coupon`, `c_code`, `c_type`, `agent_id`, `total`, `date`) 
                        VALUES ('$uid','$order','$name','$ad1','$ad2','$city','$state','$pincode','$mobile','$email','$payment_id','COD','pending','$shipping','$coupon','$ccode','$ctype','$agentId','$total','$date')";
        $row = mysqli_query($conn, $sqlCheckout);
    }

    if ($row == true) {
        echo json_encode(["message" => "radha", "orderid" => $order]);
    } else {
        echo json_encode(["message" => "invalid", "orderid" => $order]);
    }
}
?>
