<?php
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *'); // Change this to the appropriate origin URL
header('Access-Control-Allow-Methods: POST');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

include "config.php"; // Assuming this includes your database connection
date_default_timezone_set("Asia/Kolkata");

$_POST = json_decode(file_get_contents("php://input"), true);

if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    http_response_code(200);
    exit;
}
// print_r($_POST);
$oid = $_POST['oid'];
$pid = $_POST['pid']; // Now $pid is an array of product IDs
$reason = $_POST['reason'];
$aname = $_POST['aname'];
$status = $_POST['status'];
$ifsc = $_POST['ifsc'];
$bname = $_POST['bname'];
$branch = $_POST['branch'];
$acc = $_POST['acc'];
$date = date('Y-m-d'); // Change date format to match database format
// print_r($pid);
$token = createtoken(); // Get token

if ($token != null) {
    // Fetch checkout data based on $oid
    $getad = "SELECT * FROM `checkout` WHERE `orderid`='$oid'";
    $rung = mysqli_query($conn, $getad);
    $ggg = mysqli_fetch_array($rung);
    $order = $ggg['orderid'];
    $total = $ggg['total'];
    $coupon = $ggg['coupon'];
    $name = $ggg['name'];
    $ad1 = $ggg['ad1'];
    $city = $ggg['city'];
    $state = $ggg['state'];
    $pincode = $ggg['pincode'];
    $mobile = $ggg['mobile'];
    
    foreach ($_POST['pid'] as $product_id) {

$getOrderItems = "SELECT p.name, p.code AS sku ,o.qty,o.price
                  FROM `order` o 
                  JOIN products p ON o.pid = p.id 
                  WHERE o.`orderid`='$order' AND o.`pid`='$product_id'";
// "SELECT price AS name, qty, price, uid AS sku FROM `order` WHERE `orderid`='$order' AND `pid`='$product_id'";
        $orderItemsResult = mysqli_query($conn, $getOrderItems);
        $orderItem = mysqli_fetch_assoc($orderItemsResult);
        $pickupDetails[] = $orderItem;
    }
    // Schedule ExpressBees pickup
    $shippingResponse = scheduleExpressBeesPickup($order, $total, $coupon, $token, $name, $ad1, $city, $state, $pincode, $mobile,$pickupDetails);
            $shippingResponseJson = $shippingResponse;

if($shippingResponseJson == true){
    // Loop through each product ID
    foreach ($_POST['pid'] as $product_id) {
        // Insert return data into return_user table
        $sql = "INSERT INTO `return_user`(`orderid`, `pid`, `reason`, `bname`, `status`, `ifsc`, `aname`,`branch`, `ac_number`, `date`) 
                VALUES ('$oid','$product_id','$reason','$bname','$status','$ifsc','$aname','$branch','$acc','$date')";
        $run = mysqli_query($conn, $sql);
       
        


        if ($run) {
            // Update status in agentOrder table for each product
            $st = "UPDATE `agentOrder` SET `status`='RETURN' WHERE `oid`='$oid' AND `pid`='$product_id'";
            $strun = mysqli_query($conn, $st);
            
            $sto = "UPDATE `order` SET `status`='RETURN' WHERE `orderid`='$oid' AND `pid`='$product_id'";
            $struno = mysqli_query($conn, $sto);

            if (!$strun) {
                echo json_encode(["message" => "failed to update agentOrder for product ID: $product_id"]);
                exit; // Exit the loop if update fails for any product
            }
        } else {
            echo json_encode(["message" => "failed to insert into return_user for product ID: $product_id"]);
            exit; // Exit the loop if insertion fails for any product
        }
    }

    // If all operations are successful
    echo json_encode(["message" => "radha","data"=>$shippingResponseJson]);
    
}else{
            echo json_encode(["message" => $shippingResponseJson["message"]]);

    }
} else {
    echo json_encode(["message" => "failed to create token"]);
}

function createtoken()
{
    $data = array(
        'email' => 'shrutinilesh7904@gmail.com',
        'password' => 'Nilesh@1234'
    );

    $url = 'https://shipment.xpressbees.com/api/users/login';

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

    $response = curl_exec($ch);
    $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    if ($httpcode == 200) {
        $responseData = json_decode($response, true);
        return $responseData['data']; // Return the token
    } else {
        return null; // Return null if token retrieval fails
    }
}

function scheduleExpressBeesPickup($order, $total, $coupon, $token, $name, $ad1, $city, $state, $pincode, $mobile,$pickupDetailsss)
{
    
    // print_r($pickupDetailsss);
    $tt = $coupon ? $coupon : 0;

    $pickupDetails = array(
        'order_number' => $order,
        'payment_type' => "reverse",
        'order_amount' => round($total) - round($tt),
         'consignee' => array(
            'name' => $name,
            'address' => $ad1,
            'city' => $city,
            'state' => $state,
            'pincode' => $pincode,
            'phone' => $mobile
        ),
        'pickup' => array(
            'warehouse_name' => 'warehouse 1',
            'name' => 'Manglik Gold',
            'address' => '34/2 Swaminarayan Nagar, Part-2',
            'address_2' => 'Nikol Road',
            'city' => 'Ahmedabad',
            'state' => 'Gujarat',
            'pincode' => '382350',
            'phone' => '7990202540'
        ),
        'order_items' => $pickupDetailsss,
        'courier_id' => '',
        'collectable_amount' => '0'
    );
    
    
// $pickupDetails['order_items'][] = array(
//             'name' => 'Manglik Gold Jewellery Product',
//             'qty' => "1",
//             'price' => (int)$total - (int)$tt,
//             'sku' => '24'
//         );

   
    // print_r($pickupDetails);
    $expressBeesApiUrl = 'https://shipment.xpressbees.com/api/shipments2';

    // Make API call to schedule pickup
    $ch = curl_init($expressBeesApiUrl);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($pickupDetails));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
        'Content-Type: application/json',
        'Authorization: Bearer ' . $token
    ));

    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);
    return $responseData; // Return response data
}
?>
