<?php
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *'); // Change this to the appropriate origin URL
header('Access-Control-Allow-Methods: POST');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    http_response_code(200);
    exit;
}

include "config.php"; // Assuming this includes your database connection
date_default_timezone_set("Asia/Kolkata");

$_POST = json_decode(file_get_contents("php://input"), true);
$uid = $_POST['uid'];
$oid = $_POST['oid'];

// $dateBefore15Days = date('D-M-Y', strtotime('-15 days'));
$dateBefore15Days = date('Y-m-d');


$query = "SELECT o.*, p.* 
FROM `order` AS o 
JOIN products AS p ON o.pid = p.id 
WHERE o.uid='$uid' AND o.orderid='$oid' AND o.status != 'RETURN' AND o.`date` >= DATE_SUB('$dateBefore15Days', INTERVAL 15 DAY) AND o.`date` <= '$dateBefore15Days'";
    $result = mysqli_query($conn, $query);
    
    $data = array(); // Initialize an empty array
    
    while ($row = mysqli_fetch_assoc($result)) {
        // Append each row to the $data array
        $data[] = array(
            "pid" => $row['pid'],
            "qty" => $row['qty'],
            "oid" => $row['orderid'],
            "name" => $row['name'],
            "category" => $row['category'],
            "price" => $row['price'],
            "img" => $imgpath."/Products/" . $row['img'],
        );
    }
    
if ($data) {
    echo json_encode(["message" => "radha", "result" => $data]);
} else {
    echo json_encode(["message" => "No results found for the specified page".$dateBefore15Days]);
}



?>