<?php
include "config.php";
date_default_timezone_set("Asia/Kolkata");

$_POST = json_decode(file_get_contents("php://input"), true);

if (isset($_POST['status']) && isset($_POST['message']) && isset($_POST['order_number'])) {
    // Extract POST data
    $status = mysqli_real_escape_string($conn, $_POST['status']);
    $message = mysqli_real_escape_string($conn, $_POST['message']);
    $orderNumber = mysqli_real_escape_string($conn, $_POST['order_number']);

    // Create concatenated message
    $dt = "w2" . $message . "-" . $orderNumber;

    // Insert data into webhook table
    $insertSql = "INSERT INTO `webhook`(`name`, `dt`) VALUES ('$status', '$dt')";
    $insertResult = mysqli_query($conn, $insertSql);

    if ($insertResult) {
        echo "Data inserted into webhook table successfully.";
    } else {
        echo "Error inserting data: " . mysqli_error($conn);
    }

    // Update checkout table
    $updateSql = "UPDATE `checkout` SET `status`='$status' WHERE `orderid`='$orderNumber'";
    $updateResult = mysqli_query($conn, $updateSql);

    if ($updateResult) {
        echo "Checkout table updated successfully.";
    } else {
        echo "Error updating checkout table: " . mysqli_error($conn);
    }

    // Email details
    $to = "dev.mansi2606@gmail.com";
    $subject = "Webhook Data";
    $body = "Status: $status\nMessage: $message\nOrder Number: $orderNumber";
    $headers = "From: princymanu2606@gmail.com";

    // Send email
    if (mail($to, $subject, $body, $headers)) {
        echo "Email sent successfully.";
    } else {
        echo "Failed to send email.";
    }
} else {
    echo "Invalid input.";
}
?>
